<template>
    <div class="omm-view-editor">

        <template v-if="fileName && !isDir">
            <markdown-editor
                v-show="showMarkDown"
                :full-width="!showFormatted"
            />

            <markdown-view
                :raw-text="rawText"
                v-show="showFormatted"
                :full-width="!showMarkDown"
            />

        </template>

        <template v-else>
            <empty-selection />
        </template>


        <dark-mode-switch @change="handleDarkModeSwitch"/>
    </div>
</template>

<script lang="ts">
import { defineComponent, onBeforeMount, ref, Ref, watch } from "@vue/composition-api";
import { useContents, useObservers, useAttachments, useViews } from "@/compositions";
import { createNewFile } from "@/utils";

import FileName from "@/components/FileName.vue";
import MarkdownEditor from "@/components/MarkdownEditor.vue";
import MarkdownView from "@/components/MarkdownView.vue";
import DarkModeSwitch from "@/components/DarkModeSwitch.vue";
import EmptySelection from "@/components/EmptySelection.vue";

import { setAppTheme } from "@/ipc/setAppTheme";

export default defineComponent({
    name: "Editor",
    components: { DarkModeSwitch, FileName, MarkdownEditor, MarkdownView, EmptySelection },
    setup() {
        const rawText = useContents().getCurrentText();
        const fileName = useContents().getCurrentFileName;
        const isDir = useContents().isDir;
        const showMarkDown: Ref<boolean> = ref(true);
        const showFormatted: Ref<boolean> = ref(true);

        /**
         * Updates the rawText property when the text change.
         */
        const handleContentUpdated = async (content: string) => {
            const updatedContent = await useAttachments().replaceAttachmentStrings(content);
            const currentContent = await useAttachments().replaceAttachmentStrings(rawText.value);

            if (updatedContent !== currentContent) {
                rawText.value = updatedContent;
            }
        }

        /**
         * When the new document button is clicked creates a new file.
         */
        const handleNewDocument = () => {
            createNewFile();
        }

        const handleDarkModeSwitch = async (isDarkMode: boolean) => {
            const newAppTheme = isDarkMode ? 'dark' : 'light';
            await setAppTheme(newAppTheme);

            useContents().setCurrentTheme(newAppTheme);

            await useObservers().notifyObservers('appThemeChanged', {isDarkMode, newAppTheme});
        }

        onBeforeMount(() => {
            useObservers().registerObserver('newFileCreated', {
                actionName: 'ADD_CHILD_TO_NODE'
            });

            useObservers().registerObserver('newDirCreated', {
                actionName: 'ADD_CHILD_TO_NODE'
            });
        });

        const handleViewChange = (viewType: 'side-by-side'|'markdown'|'formatted') => {
            switch (viewType) {
                case 'side-by-side':
                    showMarkDown.value = true;
                    showFormatted.value = true;
                    break;

                case "formatted":
                    showMarkDown.value = false;
                    showFormatted.value = true;
                    break;

                case "markdown":
                    showMarkDown.value = true;
                    showFormatted.value = false;
            }
        }

        watch(useViews().getViewType(), (viewType) => {
            handleViewChange(viewType);
        });

        return {
            handleContentUpdated,
            handleNewDocument,
            handleDarkModeSwitch,
            rawText,
            fileName,
            isDir,
            showMarkDown,
            showFormatted
        };
    }
});
</script>

<style scoped lang="scss">
.omm-view-editor {
    height: 100%;
    position: relative;
    display: flex;
}

.file-locator {
    width: 100%;
}

::v-deep {
    .markdown-editor {
        width: 50%;
        float: left;
    }

    .markdown-view {
        float: right;
    }
}
</style>